/********************************************************************************
 *                    Nonficker Vaxination
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#include <windows.h>
#include <stdio.h>

#include "mutex.h"

#define MUTEX_BUFLEN 0x0104


void create_random_char_string(unsigned char* buffer, int buffer_len){
  register int i;

  for (i=0; i<buffer_len; ++i) {
    buffer[i] = (rand() % 26) + 'a';
  }
  buffer[i]=0;
}


int simplified_crc(unsigned char* computername, int computername_len) {
  DWORD result = 0xFFFFFFFF;
  register int i, s;
  
  //printf("Computer Name %s\n", computername);

  if (computername_len==0) return result;

  for (i=0; i<computername_len; ++i) {
    DWORD c = computername[i];

    for (s=8; s>0; --s) {

      if ((c ^ result) & 0x01)	
	result = (result>>1) ^ 0x0EDB88320;
      else
	result >>=1;

      c >>= 1;
    }
  }
  
  return result;
}


char* startup_mutex(DWORD pid, DWORD conficker_variant){
  DWORD seed = pid;
  char* buffer;

  if (conficker_variant == CONFICKER_VARIANT_C)
    seed ^=  0x630063;

  buffer = (char*) calloc(20, 1);
  if (!buffer) {
    fprintf(stderr, "calloc() failed\n");
    ExitProcess(2);
  }

  srand(seed);
  
  create_random_char_string(buffer, rand()%7 + 10);  

  return buffer;
}


DWORD mutex_code(DWORD conficker_variant){
  char buffer[MUTEX_BUFLEN];
  DWORD bsize = MUTEX_BUFLEN;

  GetComputerName(buffer, &bsize);

  if (conficker_variant == CONFICKER_VARIANT_A)
    return crc32(0, buffer, strlen(buffer));
  else
    return simplified_crc(buffer, strlen(buffer));

}
