/********************************************************************************
 *               Conficker File & Registry Checker
 *
 *
 *
 * Copyright (C) 2009  Felix Leder & Tillmann Werner
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact {leder,werner}@cs.uni-bonn.de
 *
 *******************************************************************************/


#include <windows.h>
#include <stdio.h>

#include "namegen.h"
#include "mutex.h"

#define MUTEX_BUFLEN 0x0104



int getDllName(unsigned char* buffer, int buffer_len, int conficker_variant){
  DWORD computer_chksum;
  size_t name_len;
  
  if (!buffer) return -1;

  memset(buffer, 0, buffer_len);

  computer_chksum = mutex_code(conficker_variant);

  if (conficker_variant == CONFICKER_VARIANT_B) {
    srand(computer_chksum ^ CONFICKER_B_DLLNAME_CONST);

    name_len = (rand() % 4) + 5;        
  }
  else if (conficker_variant == CONFICKER_VARIANT_C) {
    srand(computer_chksum ^ CONFICKER_C_DLLNAME_CONST);

    name_len = (rand() % 4) + 5;
    if (name_len > buffer_len-1) return -2;
    
  }
  else return -3;
  
  if (name_len > buffer_len-1) return -2;

  create_random_char_string(buffer, name_len);

  //everythin ok :)
  return 0;
}



int getRegRunKey(unsigned char* buffer, int buffer_len, int conficker_variant){
  DWORD computer_chksum;
  size_t name_len;
  
  if (!buffer) return -1;

  memset(buffer, 0, buffer_len);

  computer_chksum = mutex_code(conficker_variant);
  

  if (conficker_variant == CONFICKER_VARIANT_B) {
    srand(computer_chksum & CONFICKER_B_REGNAME_CONST);

    name_len = (rand() % 5) + 5;        
  }
  else if (conficker_variant == CONFICKER_VARIANT_C) {
    srand(computer_chksum & CONFICKER_C_REGNAME_CONST);

    name_len = (rand() % 5) + 5;        
  }
  else return -3;
  
  if (name_len > buffer_len-1) return -2;

  create_random_char_string(buffer, name_len);

  //everythin ok :)
  return 0;
}
